package com.microservices.zone.detail.mapper;

import com.microservices.common.datascope.annotation.DataScope;
import com.microservices.zone.detail.domain.ZoneDetail;
import com.microservices.zone.detail.domain.vo.ZoneDetailSearchVo;
import org.apache.ibatis.annotations.Mapper;

import java.util.List;

/**
 * 特色专区详情Mapper接口
 *
 * @author otto
 * @date 2023-05-09
 */
@Mapper
public interface ZoneDetailMapper {
    /**
     * 查询特色专区详情
     *
     * @param id 特色专区详情主键
     * @return 特色专区详情
     */
    public ZoneDetail selectZoneDetailById(Long id);

    /**
     * 查询特色专区详情列表
     *
     * @param zoneDetail 特色专区详情
     * @return 特色专区详情集合
     */
    @DataScope(deptAlias = "z")
    public List<ZoneDetail> selectZoneDetailList(ZoneDetail zoneDetail);

    /**
     * 新增特色专区详情
     *
     * @param zoneDetail 特色专区详情
     * @return 结果
     */
    public int insertZoneDetail(ZoneDetail zoneDetail);

    /**
     * 修改特色专区详情
     *
     * @param zoneDetail 特色专区详情
     * @return 结果
     */
    public int updateZoneDetail(ZoneDetail zoneDetail);

    /**
     * 删除特色专区详情
     *
     * @param id 特色专区详情主键
     * @return 结果
     */
    public int deleteZoneDetailById(Long id);

    /**
     * 批量删除特色专区详情
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteZoneDetailByIds(Long[] ids);

    /**
     * 通过组织Id查询特色专区
     *
     * @param deptId
     * @return
     */
    ZoneDetail selectZoneDetailByDeptId(Long deptId);

    /**
     * 获取专区数量
     * @param zoneDetailSearchVo
     * @return
     */
    @DataScope(deptAlias = "z")
    Integer selectZoneDetailCount(ZoneDetailSearchVo zoneDetailSearchVo);

    /**
     * 通过专区标识查找专区
     *
     * @param zoneKey
     * @return
     */
    ZoneDetail selectZoneDetailByKey(String zoneKey);

    /**
     * 根据名称查找专区
     *
     * @param name
     * @return
     */
    ZoneDetail selectZoneDetailByName(String name);
}
